Subject: bug#26422: closed (Re: bug#26422: historical feature or grand daddy bug?)

From: [email-masked] (GNU bug Tracking System)
Date: Sun, 09 Apr 2017 19:05:02 +0000

Your bug report

#26422: historical feature or grand daddy bug?

which was filed against the coreutils package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
26422: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=26422
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#26422: historical feature or grand daddy bug?
From: Paul Eggert <[email-masked]>
To: Kyle Sallee <[email-masked]>, [email-masked]
Date: Sun, 9 Apr 2017 12:04:34 -0700
List-Id: <debbugs-submit.debbugs.gnu.org>

Historically, 'sort' ignored the \n at the end of each line, so that 
empty lines (i.e., lines consisting only of a single \n) collated before 
all other lines. An earlier version of the POSIX spec was (mis)written 
to require treating the \n as part of the data, and during development 
in 1999 GNU sort was briefly changed to conform to that, but this was an 
error in the POSIX spec that was eventually fixed and GNU sort was 
changed back to the traditional behavior, before any release was made 
with the funky behavior.

So, it's not a bug that \t\n collates after \n, since "\t" is 
lexicographically after "".

As I understand it, the empty string should collate before all other 
strings in all POSIX locales, so empty lines should always sort first in 
'sort' output. I'm by no means a collation expert, though, and if I'm 
wrong I'd like to see a counterexample.

Come to think of it, 'sort' might be able to improve performance in the 
common case of sorting text files containing many empty lines, by merely 
counting the lines rather than storing them internally. I suppose this 
is a different topic, though.

Subject: historical feature or grand daddy bug?
From: Kyle Sallee <[email-masked]>
To: [email-masked]
Date: Sun, 9 Apr 2017 11:37:34 -0700
List-Id: <debbugs-submit.debbugs.gnu.org>

By the sort program
when a file is sorted
the lines which start with line feed
output earlier than lines which begin with tab.

Tab ASCII value is 9.
LF  ASCII value is 10.
Tabs should be first?

However, to strings
if the lines are converted
then to mitigate a larger address space
presumably with 0 the LF are replaced.
Yet after the LF if the 0 byte was placed
then the expected output would become.

If expected behavior becomes
then historical behavior relied upon scripts might break.

The sort.c source code was not viewed.
Therefore, a patch is not offered.
Discussion is solicited.
Concerning empty lines first.
Is it a bug?
Should it be fixed?

Because I am not on the email list;
if the topic is worth discussion
if a decision is made
then please forward.
Thanks for maintaining and sharing awesome software.